#!/usr/bin/env python
# -*- coding: utf-8 -*-

import numpy as np

# defining pauli matrices
identity = np.identity(2, dtype=complex)
pauli_x = np.array([[0, 1], [1, 0]], dtype=complex)
pauli_y = np.array([[0, -1j], [1j, 0]], dtype=complex)
pauli_z = np.array([[1, 0], [0, -1]], dtype=complex)


def Hamilton(k, m, t1, t2, phi):
    kx, ky, _ = k
    k_a = 2 * np.pi / 3. * np.array([
        kx + ky, 
        -2. * kx + ky, 
        kx - 2. * ky
    ])
    k_b = 2 * np.pi * np.array([-kx + ky, -ky, kx])
    H = 2 * t2 * np.cos(phi) * sum(np.cos(k_b)) * identity
    H += t1 * sum(np.cos(k_a)) * pauli_x
    H += t1 * sum(np.sin(k_a)) * pauli_y
    H += m * pauli_z
    H -= 2 * t2 * np.sin(phi) * sum(np.sin(k_b)) * pauli_z
    return H

def get_chern(m, t1, t2, phi, **settings):
    # This function should return the Chern number for the given
    # parameters m, t1, t2, phi. The **settings should be passed
    # on to the z2pack.surface.run method.

if __name__ == "__main__":
    # Task a)
    
    # Task b)
    
    # Task c) (optional - for advanced Python users)
